//+------------------------------------------------------------------+
//|                                                 MyExpert_v03.mq4 |
//|                                                    Charkin Anton |
//+------------------------------------------------------------------+
#property copyright "Charkin Anton"
//-------------------------------------------------------------------+
//MyExpert                                                           |
//   . =)                           |
//-------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

extern double LotNachalo =0.01;          //  (0.01) 
extern double SLA =120;                  // StopLossAuto    ()
extern double TPA =120;                  // TakeProfitAuto    ()
extern double SL =70;                    // StopLoss   ,   
extern double TP =70;                    // TakeProfit  
extern bool Nap = true;                  //   Buy(true) Sell(false)                                          
extern bool Sys = true;                  //   , .  
extern double K =3;                      //   

int MassSerii [10];                      //     //  
int Count = 0;                           //   ()  //  
int Ticket;                              //                                           
int Tip=-1;                              //  .  (B=0,S=1)
double Lot;                              // .   .
double LotCl;                            // .       
double uroven;                           //    
string Symb;                             //  . 
bool Work = true;                        //   
bool nachalo = true;                     //     true    false
bool Ans  = false;                       //    
bool LotN = true;                        //   -   
//-------------------------------------------------------------------+
int init()                                            //.  init()
  {                               
   // .  -  
   Symb=Symbol();                          
   Alert ("Symb = ", Symb);                           // 
   Alert ("  = ", Lot);                   //                                         
   return;                                            //  init()
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()                                            //.  start()
{    
 if(Work==false)                                       //  
 {
  Alert(" .   .");
  return;                                              //   start()
 }        
//--------------------------------------------------------------------
 //      
 if (nachalo == false)
 {
//------------------------------------------------------------------
  if (Nap == true)                              //     Buy     
  { 
   if (ProfitBuy() == False)                    //    Buy 
   {
    LossBuy();                                  //    Buy                                                                             
   }
   return;                                      //   start()                                     
  } 
//------------------------------------
  if (Nap == false)                             //     Sell
  {   
   if (ProfitSell() == False)                   //    Sell 
   {
    LossSell();                                 //    Sell 
   }
   return;
  } 
 } 
//----------------------------------------------------------------------
 //        
 if (nachalo == true) 
 {  
  if (Sys == true)Alert("  CloseAllOrders() ");
  CloseAllOrdres();                              //   
  nachalo = false;                               //      
  if (Nap == true)                               //    
  {
   Alert (" = ",TP,"  = ",SL );        //
   Alert ("  " );      //  
  }
  else                                           //    
  { 
   Alert (" = ",TP,"  = ",SL );        //
   Alert ("  " );      //
  }
 }  
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()                                    //.  deinit()
  {
   if (Sys == true) Alert ("  deinit()  ");//
   return;                                      //  deinit()
  }
//+------------------------------------------------------------------+
//| expert  function                                 |
//+------------------------------------------------------------------+
//    
bool CloseAllOrdres()
{
 int i;                                         // 
 //      . .
 if (Sys == true) Alert("   = ", OrdersTotal());
 if (OrdersTotal() != 0)                        //     
 {   
  //     
  for(i=0; i<=OrdersTotal(); i++) 
  {
   if(OrderSelect(i,SELECT_BY_POS)==true)       //   
   {                                            //  :
    if(OrderSymbol()!=Symb)continue;            //   . 
    Ticket=OrderTicket();                       //  . .
    Tip   =OrderType();                         //   .
    LotCl =OrderLots();                         //  
    CloseOrder(Ticket,LotCl,Tip);               //  
   }
  }
  if (OrdersTotal() == 0)                       //   
    if (Sys == true)                            //    
       Alert("   ");   //   
 }       
 //                                       
 OpenOrder(True);                               // true        
 return;
} 
//--------------------------------------------------------------------
bool ProfitBuy()
{
 int i; 
 //       ( + 80 )
 if (Bid >= uroven + TP*Point)
 {
  Alert (" - Bid: ", DoubleToStr(Bid,5) ," >= ",
                           DoubleToStr(uroven + TP*Point,5));
  LotN=True;                            
  CloseAllOrdres();
  Alert ("  ...   =) ");   
  return(true);
 }
 else
  return(false); 
}
//--------------------------------------------------------------------
bool ProfitSell()
{
 int i; 
 //       ( - 100 )
 if (Ask <= uroven - TP*Point)
 {
  Alert (" - Ask: ", DoubleToStr(Ask,5) ," <= ",
                           DoubleToStr(uroven - TP*Point,5));
  LotN=true;
  CloseAllOrdres();
  Alert ("  ...   =) ");      
  return(true);
 }
 else 
  return(false);
}
//--------------------------------------------------------------------
bool LossBuy()
{ 
 //       ( - 80 )
 if (Bid <= uroven - SL*Point)
 {
  Alert (" - Bid: ", DoubleToStr(Bid,5) ," <= ", 
                           DoubleToStr(uroven - SL*Point,5));
  LotN=false;
  CloseAllOrdres();
  Alert (" ... =(  ");     
  return(true);
 }
 else
  return(false); 
}
//--------------------------------------------------------------------
bool LossSell()
{ 
 //       ( + 100 )
 if (Ask >= uroven + SL*Point)
 {
  Alert (" - Ask: ", DoubleToStr(Ask,5) ," >= ", 
                           DoubleToStr(uroven + SL*Point,5));
  LotN=false;
  CloseAllOrdres();
  Alert ("  ... =(  ");  
  return(true);
 }
 else 
  return(false); 
} 
//------------------------------------------------------------------- 
//  
bool OpenOrder(bool N)                         //(N- , True = Buy, False = Sell)
{
 double S,T; 
 while(true)  
 {                                             //   .                                     //(S-Stop, T-Profit)
 //    ...
 if (N == True)
 {
  RefreshRates();                              //  
  S = Bid - SLA*Point;                         //  SL .            
  T = Bid + TPA*Point;                         //  TP .
  Alert("  Buy.  ..");  
  Ticket = OrderSend(Symb,OP_BUY, Lots() ,Ask,2,S,T);// Buy
  if (Ticket > 0)                              //  :)
  {
   Alert ("  Buy ",Ticket);
   OrderSelect(Ticket,SELECT_BY_TICKET);
   uroven = OrderOpenPrice();   
   Alert("",  DoubleToStr(uroven,5));
   Count++;                                    //    1
   return(true);
  }
  if (Fun_Error(GetLastError())==1)            //  
   continue;                                   //                                                
 }
 //    ...
 if (N == False)
 {
  RefreshRates();                              //    
  S = Ask + SLA*Point;                         //  SL .              
  T = Ask - TPA*Point; 
  Alert("  Sell.  ..");
  Ticket = OrderSend(Symb,OP_SELL, Lots() ,Bid,2,S,T);// Sell
  if (Ticket > 0)                              //  :)
   {
    Alert ("  Sell ",Ticket);
    OrderSelect(Ticket,SELECT_BY_TICKET);
    uroven = OrderOpenPrice();
    Alert("",  DoubleToStr(uroven,5));
    Count++;                                   //   1
    return(true);
   }
  if (Fun_Error(GetLastError())==1)            //  
   continue;                                   //                                                  
 }
 break;                                        //   while
 }
 return;                                       // 
}
//--------------------------------------------------------------------
//  
int CloseOrder(int Ticket, double Lot, int Tip)//Ticket  , Lot  , Tip  (Buy,Sell)
{
 while(true)
 {
  if (Tip == 0) 
  {
   Alert("  Buy ",Ticket,".  ..");
   RefreshRates();                        //  
   Ans=OrderClose(Ticket,Lot,Bid,2);      //  Buy
   if (Ans==true)                         //  :)
   {
    Alert ("  Buy ",Ticket);
    break;                               //    
   }
   if (Fun_Error(GetLastError())==1)      //  
    continue;                              //  
   return;
  }
  if (Tip == 1)
  {
   Alert("  Sell ",Ticket,".  ..");
   Ans=OrderClose(Ticket,Lot,Ask,2);      //  Sell
   if (Ans==true)                         //  :)
   {
    Alert ("  Sell ",Ticket);
    break;                               //    
   }
   if (Fun_Error(GetLastError())==1)      //  
    continue;                           //  
   return; 
  }
 }
}
//---------------------------------------------------------------------+
//   
double Lots ()
{
 if (LotN == False)
 {                              //0.01        
  Lot = Lot*100;                //1
  Lot = MathRound( Lot * K );   //1*3=3
  if (Lot > 1500)
  {
   Lot=LotNachalo;
  } 
  else
  Lot=Lot*0.01;                 //3*0.01 = 0.03
  return(Lot);
 }
 if (LotN == true)// 
 {
  Count = 0;
  Lot=LotNachalo;
  MassSerii[Count]++;                           //   
  LotN=False;
  return(Lot);
 } 
}
//--------------------------------------------------------------------
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {   //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  } 
//-------------------------------------------------------------------+